unit DaneOPracwoniku;

interface

 uses Classes;

 type
  TDaneOPracwoniku = class
  private
    { Pola, funkcje i procedury prywatne}
    fImie            : string;
    fNazwisko        : string;
    fRokZatrudnienia : Integer;

    procedure SetImie(const value: string);
    procedure SetNazwisko(const value: string);
    procedure SetRokZatrudnienia(const value: Integer);

    //procedury
    procedure Clear();
  public
    //waciwoci
    property Imie            : string  read fImie            write SetImie;
    property Nazwisko        : string  read fNazwisko        write SetNazwisko;
    property RokZatrudnienia : Integer read fRokZatrudnienia write SetRokZatrudnienia;


    //konstruktor i destruktor
    constructor Create(imie : string; nazwisko : string; rokZatrudnienia : Integer);
    destructor Destroy; override;
  end;

implementation

procedure TDaneOPracwoniku.SetImie(const value: string);
begin
if value <> Self.fImie then Self.fImie := value;
end;

procedure TDaneOPracwoniku.SetNazwisko(const value: string);
begin
if value <> Self.fNazwisko then Self.fNazwisko := value;
end;

procedure TDaneOPracwoniku.SetRokZatrudnienia(const value: Integer);
begin
if value <> Self.fRokZatrudnienia then Self.fRokZatrudnienia := value;
end;

procedure TDaneOPracwoniku.Clear();
begin
Self.fImie := '';
Self.fNazwisko := '';
Self.fRokZatrudnienia := 0;
end;

constructor TDaneOPracwoniku.Create(imie : string; nazwisko : string; rokZatrudnienia : Integer);
begin
inherited Create();

//w konstruktorze czycz wszystkie pola
Self.Clear();

Self.fImie := imie;
Self.fNazwisko := nazwisko;
Self.fRokZatrudnienia := rokZatrudnienia;
end;

//destruktor
destructor TDaneOPracwoniku.Destroy();
begin
Self.Clear();

inherited Destroy();
end;

end.
