unit Pracownicy;

interface

 uses Classes, Pracownik, Contnrs, SysUtils, DaneOPracwoniku, FormaZatrudnienia;

 type
  TPracownicy = class
  private
    { Pola, funkcje i procedury prywatne}
     fSciezkaDoPliku : TFileName;
     fPracownicy  : TObjectList; //lista pracownikow

    //procedury/funkcje
    procedure ClearScreen();
    procedure BladDanych();
    function PobierzDanePracownika() : TPracownik;
    procedure WyswietlDaneOPracowniku(p : TPracownik; nr : Integer; ile : Integer);
    procedure ListaJestPusta();
  public
    { Waciwoci, pola, funkcje i procedury publiczne}
    property Pracownicy: TObjectList read fPracownicy;

    //konstruktor i destruktor
    constructor Create(plikZDanymi : TFileName);
    destructor Destroy(); override;

    //procedury, funkcje

    //pobieranie informacji o pracowniku, dodawanie do bazy
    procedure DodajPracownikaDoBazy();
    //wywietlenie zawartoci bazy
    procedure WyswietlZawartoscBazy();
    procedure WyswietlDanePracownika();
    //usunicie pracownika
    procedure UsunPracownika();

    //odczyt/zapis pliku
    procedure OdczytajDaneZPliku();
    procedure ZapiszDaneDoPliku();

    //wywietlenie informacji o stawkach itd
    procedure PokazKonfuguracje();
  end;

implementation


//gdy le pzekazane dane
procedure TPracownicy.BladDanych();
begin
Self.ClearScreen();
writeln;
writeln;
writeln('Nie udalo sie wyswietlic informacji o pracowniku !!!');
writeln;
end;

//czyszczenie ekranu
procedure TPracownicy.ClearScreen();
var i : Integer;
begin
for i := 0 to 50 do writeln;
end;

//gdy na licie nie ma nic wywietlam informacj
procedure TPracownicy.ListaJestPusta();
begin
Self.ClearScreen();
writeln('Lista pracownikow jest pusta !!!');
ReadLn;
end;

//wywietlanie informacji o pracowniku
procedure TPracownicy.WyswietlDaneOPracowniku(p : TPracownik; nr : Integer; ile : Integer);
begin
Self.ClearScreen();
if (p <> nil) then
  begin
      try
          //przechwytuj wszystko co zostao wcinite
          writeln('Dane o pracowniku ['+ IntToStr(nr+1) + '/' + IntToStr(ile) + ']:');
          writeln('Imie: ' + p.DaneOPracowniku.Imie);
          writeln;
          writeln('Nazwisko: ' + p.DaneOPracowniku.Nazwisko);
          writeln;
          writeln('Rok zatrudnienia: ' + IntToStr(p.DaneOPracowniku.RokZatrudnienia) + 'r');
          writeln;
          writeln('Place zasadnicza: ' + FloatToStr(p.PlacaZasadnicza) + 'zl');
          writeln;
          writeln('Premia: ' + FloatToStr(p.Premia) + 'zl');
          writeln;
          writeln('Ilosc godzin: ' + FloatToStr(p.IloscGodzin) + 'h');
          writeln;
          writeln('Wynagrodzenie calkowite: ' + FloatToStr(p.Wynagrodzenie) + 'zl');
          writeln;
          case p.FormaZatrudnienia of
            UmowaOPrace: writeln('Forma zatrudnienia: Umowa o prace');
            DzialalnoscGospodarcza: writeln('Forma zatrudnienia: Dzialalnosc gospodarcza');
          end;
      except
          Self.BladDanych();
      end;
  end
else Self.BladDanych();
end;


//Procedura wywietla wielkos stawek
procedure TPracownicy.PokazKonfuguracje();
begin
Self.ClearScreen();
ReadLn;

writeln('Konfiguracja programu:');
writeln('Ilosc godzin w miesiacu do przepracowania: ' + IntToStr(iloscGodzinWMiesiacu));
writeln('Stawka godzinowa: ' + IntToStr(stawkaGodzinowa) + 'zl');
writeln('Stawka za nadgodziny: ' + IntToStr(stawkaZaNadgodziny) + 'zl');

ReadLn;
end;

//procedura usuwa pracownika o podanym imieniu i nazwisku
procedure TPracownicy.UsunPracownika();
var i : Integer;
    imie, nazwisko : string;
    indexList : TStringList;
begin
Self.ClearScreen();

if ((Self.fPracownicy <> nil) and (Self.fPracownicy.Count > 0)) then
  begin
       //przechwytuj wszystko co zostao wcinite
       readln;

       //pytam o podanie imienia i nazwiska
       //pobranie informacji
       writeln('Usuniecie z listy na podstawie imienia i nazwiska');
       writeln('Podaj imie pracownika, ktorego chcesz usunac:');
       readln(imie);
       writeln('Podaj nazwisko pracownika:');
       readln(nazwisko);

       indexList := TStringList.Create();
       try
         //wyszukuj pracownikw o takik danych
         for i := 0 to Self.fPracownicy.Count - 1 do
           begin
                //sprawdzam dane o pracowniku
                if ((AnsiSameStr(imie, TPracownik(fPracownicy[i]).DaneOPracowniku.Imie)) and
                    (AnsiSameStr(nazwisko, TPracownik(fPracownicy[i]).DaneOPracowniku.Nazwisko))) then
                  begin
                       //dodaje do listy indexu
                       indexList.Add(IntToStr(i));
                  end;
           end;



         //sprawdzam czy znaleziono jakich pracownikw o podanym imieniu i nazwisku
         if indexList.Count > 0 then
           begin
                 //jeeli znaleziono tylko 1 pracownika to usuwam go
                 if indexList.Count = 1 then
                    begin
                         fPracownicy.Delete(StrToInt(indexList[0])); //usunicie pracownika

                         Self.ClearScreen();
                         writeln;
                         writeln;
                         writeln('Pracownik ' + imie + ' ' + nazwisko + ' zosta usuniety');
                         writeln('Nacisnij dowolny klawisz aby kontynuowac');
                         writeln;
                         readln;
                    end
                 else
                    begin
                         Self.ClearScreen();
                         writeln('Znaleziono wiecej niz jednego pracownika o podanych danych:');
                         writeln('Imie: ' + imie);
                         writeln('Nazwisko: ' + nazwisko);
                         writeln('Usuniecie nie jest mozliwe, program jak na razie tego nie przewiduje :)');
                         ReadLn;
                    end;
           end
          else
           begin
                Self.ClearScreen();
                writeln('Nie znaleziono pracownika o imieniu i nazwisku: ' + imie + ' ' + nazwisko + ' !!!');
                ReadLn;
           end;
       finally
          indexList.Clear();
          indexList.Free();
       end;
  end
else Self.ListaJestPusta();
end;

//procedura wywietla dane o pracowniku na podstawie imienia i nazwiska
procedure TPracownicy.WyswietlDanePracownika();
var i, index : Integer;
    c : Char;
    imie, nazwisko : string;
    indexList : TStringList;
begin
Self.ClearScreen();

if ((Self.fPracownicy <> nil) and (Self.fPracownicy.Count > 0)) then
  begin
       //przechwytuj wszystko co zostao wcinite
       readln;

       //pytam o podanie imienia i nazwiska
       //pobranie informacji
       writeln('Wyswietlenie informacji o pracowniku na podstawie imienia i nazwiska');
       writeln('Podaj imie pracownika:');
       readln(imie);
       writeln('Podaj nazwisko pracownika:');
       readln(nazwisko);

       indexList := TStringList.Create();
       try
         //wyszukuj pracownikw o takik danych
         for i := 0 to Self.fPracownicy.Count - 1 do
           begin
                //sprawdzenie czy pracownik o takim samym imieniu i nazwisku
                if ((AnsiSameStr(imie, TPracownik(Self.fPracownicy[i]).DaneOPracowniku.Imie)) and
                    (AnsiSameStr(nazwisko, TPracownik(Self.fPracownicy[i]).DaneOPracowniku.Nazwisko))) then
                  indexList.Add(IntToStr(i));
           end;



         //sprawdzam czy znaleziono jakich pracownikw o podanym imieniu i nazwisku
         if indexList.Count > 0 then
           begin
                 //wywietlam w ptli informacje o pracownikach
                 for i := 0 to indexList.Count - 1 do
                   begin
                        index := StrToInt(indexList[i]);

                        //wywietlam dane o pracowniku
                        Self.WyswietlDaneOpracowniku(TPracownik(Self.fPracownicy[index]), i, indexList.Count);

                        //stopka
                        writeln;
                        writeln;
                        writeln('--------------------------------------------------');
                        writeln('(P)rzerwij, ENTER - nastepny');
                        readln(c);
                        if ((c = 'p') or (c = 'P')) then Break;
                   end;
           end
          else
           begin
                Self.ClearScreen();
                writeln('Nie znaleziono pracownika o imieniu i nazwisku: ' + imie + ' ' + nazwisko + ' !!!');
                ReadLn;
           end;
       finally
          indexList.Clear();
          indexList.Free();
       end;
  end
else Self.ListaJestPusta();
end;

//procedura wywietla zawarto listy pracownikw element po elemencie
procedure TPracownicy.WyswietlZawartoscBazy();
var i : Integer;
    c : Char;
begin
//przechwytuj wszystko co zostao wcinite
readln;

if ((Self.fPracownicy <> nil) and (Self.fPracownicy.Count > 0)) then
  begin
       //wywietlam w ptli informacje o pracownikach
       for i := 0 to Self.fPracownicy.Count - 1 do
         begin
              //wywietlam dane o pracowniku
              Self.WyswietlDaneOpracowniku(TPracownik(Self.fPracownicy[i]), i, Self.fPracownicy.Count);

              //stopka
              writeln;
              writeln;
              writeln('--------------------------------------------------');
              writeln('(P)rzerwij, ENTER - nastepny');
              readln(c);
              if ((c = 'p') or (c = 'P')) then Break;
         end;
  end
else Self.ListaJestPusta();
end;

//Funkcja pobierajca i zwracajca dane o pracowniku
function TPracownicy.PobierzDanePracownika() : TPracownik;
var formaZatrudnienia : TFormaZatrudnienia;
    imie, nazwisko : string;
    rokZatrudnienia, formaZatrudnieniaRead : Integer;
    iloscGodzin : Real;
begin
Self.ClearScreen();
try
    //przechwytuj wszystko co zostao wcinite
    readln;

    //pobranie informacji
    writeln('Podaj imie pracownika:');
    readln(imie);

    writeln('Podaj nazwisko pracownika:');
    readln(nazwisko);

    writeln('Podaj rok zatrudnienia:');
    readln(rokZatrudnienia);

    writeln('Ilosc godzin:');
    readln(iloscGodzin);

    writeln('Forma zatrudnienia:');
    writeln('1 - Umowa o prace');
    writeln('2 - Dzialalnosc gospodarcza');
    readln(formaZatrudnieniaRead);

    //ustawiam form zatrudnienia
    case formaZatrudnieniaRead of
      1: formaZatrudnienia := UmowaOPrace;
      2: formaZatrudnienia := DzialalnoscGospodarcza;
      else raise Exception.Create('Blednie podana forma zatrudnienia !!!');
    end;


    //utworzenie obiektu pracownik
    Result := TPracownik.Create(iloscGodzin,
                                //tworze obiekt dane o pracowniku
                                TDaneOPracwoniku.Create(imie,
                                                        nazwisko,
                                                        rokZatrudnienia),
                                formaZatrudnienia);
except
  on ex : Exception do
    begin
        Self.ClearScreen();
        writeln;
        writeln;
        writeln('Nie udalo sie pobrac informacji o nowym pracowniku !!!');
        writeln('Conajmniej jeden z wymaganych parametrow zostal podany blednie lub nie zostal podany wcale.');
        writeln(ex.Message);
        writeln;
        readln;
        Result := nil;
    end;
end;
end;

//Procedura dodajca pracownika do bazy (listy)
procedure TPracownicy.DodajPracownikaDoBazy();
var p : TPracownik;
begin
if Self.fPracownicy <> nil then
  begin
       p := Self.PobierzDanePracownika();

       if p <> nil then
         begin
              Self.fPracownicy.Add(p);

              Self.ClearScreen();
              writeln;
              writeln;
              writeln('Nowy pracownik zostal dodany do listy');
              writeln('Nacisnij dowolny klawisz aby kontynuowac');
              writeln;
              readln;
         end;
  end;
end;

//Procedura wczytuje dane o pracownikach z pliku
procedure TPracownicy.OdczytajDaneZPliku();
var
  stream : TFileStream;
  reader : TReader;
  p      : TPracownik;
begin
if FileExists(Self.fSciezkaDoPliku) then
  begin
      stream := TFileStream.Create(Self.fSciezkaDoPliku, fmOpenRead);
      try
        reader := TReader.Create(stream, $ff);
        try
          with reader do begin
            ReadSignature;
            ReadListBegin;
            while not EndOfList do begin
              ReadListBegin;
              ReadString;
              while not EndOfList do begin
                p := TPracownik.Create();
                try
                  p.ReadFromStream(reader);
                except
                  p.Free;
                  raise;
                end;
                Self.fPracownicy.Add(p);
              end;
              ReadListEnd;
            end;
            ReadListEnd;
          end;
        finally
          reader.Free;
        end;
      finally
        stream.Free;
      end;
end;
end;


procedure TPracownicy.ZapiszDaneDoPliku();
var
  stream : TFileStream;
  writer : TWriter;
  i      : Integer;
begin
stream := TFileStream.Create(Self.fSciezkaDoPliku, fmCreate or fmOpenWrite);
try
  writer := TWriter.Create(stream, $ff);
  try
    with writer do begin
      WriteSignature;
      WriteListBegin;
      for i := 0 to Self.fPracownicy.Count - 1 do begin
        WriteListBegin;
        WriteString(TPracownik(Self.fPracownicy[i]).ClassName);
        TPracownik(Self.fPracownicy[i]).WriteToStream(writer);
        WriteListEnd;
      end;
      WriteListEnd;
    end;
  finally
    writer.Free;
  end;
finally
  stream.Free;
end;
end;









constructor TPracownicy.Create(plikZDanymi : TFileName);
begin
     inherited Create();

     //w konstruktorze tworz list pracownikw
     Self.fPracownicy := TObjectList.Create();

     //oraz wczytuj dane o pracownikach z pliku
     Self.fSciezkaDoPliku := plikZDanymi;
     Self.OdczytajDaneZPliku();
end;

//destruktor
destructor TPracownicy.Destroy();
begin
  if (Self.fPracownicy <> nil) then
    begin
         Self.fPracownicy.Clear();

         FreeAndNil(Self.fPracownicy);
    end;

  Self.fSciezkaDoPliku := EmptyStr;

  inherited Destroy();
end;
end.


