program ProjPracownik;

{$APPTYPE CONSOLE}

uses
  SysUtils, Controls, Forms,
  Pracownik in 'Pracownik.pas',
  DaneOPracwoniku in 'DaneOPracwoniku.pas',
  FormaZatrudnienia in 'FormaZatrudnienia.pas',
  Pracownicy in 'Pracownicy.pas';

//zmienne
var zatrudnieniPracownicy : TPracownicy; //lista pracownikw
    c : Char; //nacinity klawisz
    fn : TFileName; //pena cieka do pliku z danymi

//stae
const nazwaPlikuZDanymi : TFileName = 'dane.dat'; //nazwa pliku do ktrego wpisywane s dane o pracownikach


//procedura wywietlajca manu
procedure WyswietlMenu();
   var i : Integer;
begin
//czyszcze ekran
for i := 0 to 50 do writeln;

//Informacja
writeln('********************************************************************');
writeln('*                      Baza danych pracownikow                     *');
writeln('********************************************************************');
writeln;
writeln;
writeln;
writeln('#########################################');
writeln('# Menu programu                         #');
writeln('# --------------------------------------#');
writeln('# (D)odaj pracownika do listy.          #');
writeln('# (P)rzegladaj dane pracownikow.        #');
writeln('# (I)nformacje o pracowniku.            #');
writeln('# (U)sun pracownika.                    #');
writeln('# (K)onfiguracja                        #');
writeln('# --------------------------------------#');
writeln('# (Z)akoncz program                     #');
writeln('#########################################');
end;



//program gwny
begin
c := #0; //ustawiam wcinity klawisz na 0

//tworz obiekt Pracownikcy (lista pracownikw) i jednoczenie odczytuj dane z pliku jeeli taki istnieje
fn := ExtractFilePath(Application.ExeName) + nazwaPlikuZDanymi;

zatrudnieniPracownicy := TPracownicy.Create(fn);
try
    if (zatrudnieniPracownicy <> nil) then
      begin
        //ptla gwna programu
          repeat
            //wywietlam menu kadorazowo po przejciu procedury
            WyswietlMenu();

            //czekam na nacinicie klawisza
            read(c);

            //zalenie od tego co wybrano tzn jaki klawisz nacinito
            case c of
              //D = dodaj pracownika do bazy
              'd': zatrudnieniPracownicy.DodajPracownikaDoBazy();
              'D': zatrudnieniPracownicy.DodajPracownikaDoBazy();
              //P = przegldanie zawartoci bazy
              'p': zatrudnieniPracownicy.WyswietlZawartoscBazy();
              'P': zatrudnieniPracownicy.WyswietlZawartoscBazy();
              //i = Wywietlenie informacji o pracowniku
              'i': zatrudnieniPracownicy.WyswietlDanePracownika();
              'I': zatrudnieniPracownicy.WyswietlDanePracownika();
              //u = Usuwanie pracownika
              'u': zatrudnieniPracownicy.UsunPracownika();
              'U': zatrudnieniPracownicy.UsunPracownika();
              //k = Konfiguracja
              'k': zatrudnieniPracownicy.PokazKonfuguracje();
              'K': zatrudnieniPracownicy.PokazKonfuguracje();
            end;
          until ((c = 'z') or (c = 'Z'));
      end;

    zatrudnieniPracownicy.ZapiszDaneDoPliku();
finally
  FreeAndNil(zatrudnieniPracownicy);
  fn := '';
  c := #0
end;
end.
